//
// obeڍ׏擾\tg kmBattInfo
//
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ExtCtrls;

const
  ProgNameStr = 'kmBattInfo';
  VerDateStr = '2008-Feb-24(Sun)';

//
// DDK \̐錾
//

type
  HDEVINFO = Pointer;
  LPVOID = Pointer;
  LONG = Longint;

type
  TGUID = record
    Data1: DWORD;
    Data2: Word;
    Data3: Word;
    Data4: array [0..7] of Byte;
  end;

type
  LPGUID = ^TGUID;

type
  SP_DEVICE_INTERFACE_DATA = record
    cbSize: DWORD;
    Guid: TGUID;
    Flags: DWORD;
    Reserve: Pointer;
  end;

type
  PSP_DEVICE_INTERFACE_DATA = ^SP_DEVICE_INTERFACE_DATA;

type
  SP_DEVINFO_DATA = record
    cbSize: DWord;
    Guid: TGUID;
    DevInst: DWORD;
    Reserve: DWORD;
  end;

type
  PSP_DEVINFO_DATA = ^SP_DEVINFO_DATA;

type
  SP_DEVICE_INTERFACE_DETAIL_DATA = packed record
    cbSize: DWORD;
    DevicePath: array [0..0] of AnsiChar; // : array of AnsiCharƃ_
                // SizeOf(SP_DEVICE_INTERFACE_DETAIL_DATA)̒l5̕Kv
                // ݂BJB
  end;

type
  PSP_DEVICE_INTERFACE_DETAIL_DATA  = ^SP_DEVICE_INTERFACE_DETAIL_DATA;

type
  BATTERY_QUERY_INFORMATION_LEVEL = (BatteryInformation,
                                     BatteryGranularityInformation,
                                     BatteryTemperature,
                                     BatteryEstimatedTime,
                                     BatteryDeviceName,
                                     BatteryManufactureDate,
                                     BatteryManufactureName,
                                     BatteryUniqueID,
                                     BatterySerialNumber);

type
  BATTERY_QUERY_INFORMATION = record
    BatteryTag: ULONG;
    InformationLevel: BATTERY_QUERY_INFORMATION_LEVEL;
    AtRate: LONG;
  end;

Type
  BATTERY_INFORMATION = record
    Capabilities: ULONG;
    Technology: UCHAR;
    Reserved: array [0..2] of UCHAR;
    Chemistry: array [0..3] of UCHAR;
    DesignedCapacity: ULONG;
    FullChargedCapacity: ULONG;
    DefaultAlert1: ULONG;
    DefaultAlert2: ULONG;
    CriticalBias: ULONG;
    CycleCount: ULONG;
  end;

type
  BATTERY_WAIT_STATUS = record
    BatteryTag: ULONG;
    Timeout: ULONG;
    PowerState: ULONG;
    LowCapacity: ULONG;
    HighCapacity: ULONG;
  end;

type
  BATTERY_STATUS = record
    PowerState: ULONG;
    Capacity: ULONG;
    Voltage: ULONG;
    Rate: LONG;
  end;

type
  BATTERY_REPORTING_SCALE = record
    Granularity: DWORD;
    Capacity: DWORD;
  end;

//
// DDK 萔錾
//

const GUID_DEVICE_BATTERY: TGUID = (Data1:$72631e54; Data2:$78A4; Data3:$11d0;
                      Data4:($bc, $f7, $00, $aa, $00, $b7, $b3, $2a));
const DIGCF_DEFAULT = $00000001;
const DIGCF_PRESENT = $00000002;
const DIGCF_ALLCLASSES = $00000004;
const DIGCF_PROFILE = $00000008;
const DIGCF_DEVICEINTERFACE = $00000010;
const FILE_DEVICE_BATTERY = $00000029;
const FILE_READ_ACCESS = $0001;
const METHOD_BUFFERED = 0;

const BATTERY_CAPACITY_RELATIVE = $40000000;
const BATTERY_IS_SHORT_TERM = $20000000;
const BATTERY_SET_CHARGE_SUPPORTED = $00000001;
const BATTERY_SET_DISCHARGE_SUPPORTED = $00000002;
const BATTERY_SYSTEM_BATTERY = $80000000;

const BATTERY_CHARGING = $00000004;
const BATTERY_CRITICAL = $00000008;
const BATTERY_DISCHARGING = $00000002;
const BATTERY_POWER_ON_LINE = $00000001;

const BATTERY_UNKNOWN_RATE = $80000000;

//
// DelphiłCTL_CODE}NgȂ̂ŌXɓWJ
//
const IOCTL_BATTERY_QUERY_TAG = (FILE_DEVICE_BATTERY shl 16) or
                                (FILE_READ_ACCESS shl 14) or ($10 shl 2) or
                                METHOD_BUFFERED;
const IOCTL_BATTERY_QUERY_INFORMATION = (FILE_DEVICE_BATTERY shl 16) or
                                         (FILE_READ_ACCESS shl 14) or
                                         ($11 shl 2) or METHOD_BUFFERED;
const IOCTL_BATTERY_QUERY_STATUS = (FILE_DEVICE_BATTERY shl 16) or
                                    (FILE_READ_ACCESS shl 14) or
                                    ($13 shl 2) or METHOD_BUFFERED;

//
// DDK ֐錾
//

function SetupDiGetClassDevs(const ClassGuid: LPGUID;
                             Enumerator: LPCTSTR;
                             hwndParent: HWND;
                             Flags: DWORD
                            ): HDEVINFO;
                            stdcall;

function SetupDiGetClassDevs; external 'setupapi.dll' name
                              'SetupDiGetClassDevsA';

function
  SetupDiEnumDeviceInterfaces(DeviceInfoSet: HDEVINFO;
                              DeviceInfoData: PSP_DEVINFO_DATA;
                              const InterfaceClassGuid: LPGUID;
                              MemberIndex: DWORD;
                              DeviceInterfaceData: PSP_DEVICE_INTERFACE_DATA
                             ): Boolean;
                             stdcall;

function SetupDiEnumDeviceInterfaces; external 'setupapi.dll' name
                              'SetupDiEnumDeviceInterfaces';

function
  SetupDiGetDeviceInterfaceDetail(DeviceInfoSet: HDEVINFO;
                   DeviceInterfaceData: PSP_DEVICE_INTERFACE_DATA;
                   DeviceInterfaceDetailData: PSP_DEVICE_INTERFACE_DETAIL_DATA;
                   DeviceInterfaceDetailDataSize: DWORD;
                   RequiredSize: PDWORD;
                   DeviceInfoData: PSP_DEVINFO_DATA
                   ): Boolean; stdcall;

function SetupDiGetDeviceInterfaceDetail; external 'setupapi.dll' name
                              'SetupDiGetDeviceInterfaceDetailA';

function SetupDiDestroyDeviceInfoList(DeviceInfoSet: HDEVINFO): Boolean;
                                                                stdcall;

function SetupDiDestroyDeviceInfoList; external 'setupapi.dll' name
                              'SetupDiDestroyDeviceInfoList';

function DeviceIoControl(hDevice: THANDLE;
                         dwIoControlCode: DWORD;
                         lpInBuffer: LPVOID;
                         nInBufferSize: DWORD;
                         lpOutBuffer: LPVOID;
                         nOutBufferSize: DWORD;
                         lpByteReturned: LPDWORD;
                         lpOverlapped: POVERLAPPED): Boolean; stdcall;

function DeviceIoControl; external 'kernel32.dll' name 'DeviceIoControl';

//
// DDK܂
//

//
// GetSystemPowerStatuŎ擾f[^𕶎ɕϊ
//

type
  TkmSystemPowerStatusStr = record
    RetBool: Boolean;
    ACLineStatus: String;
    BatteryFlag: String;
    BatteryFlagStr: String;
    BatteryLifePercent: String;
    Reserved: String;
    BatteryLifeTime: String;
    BatteryFullLifeTime: String;
  end;

type
  PTkmSystemPowerStatus = ^TkmSystemPowerStatusStr;

//
// obeڍ׏W߂\()
//
type
  TkmBattInfoStr = record
    // DeviceIoControl - IOCTL_BATTERY_QUERY_TAG
    BatteryTag: String;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
    //   BatteryInformation
    Capabilities: String;
    BATTERY_CAPACITY_RELATIVE: String;
    BATTERY_IS_SHORT_TERM: String;
    BATTERY_SET_CHARGE_SUPPORTED: String;
    BATTERY_SET_DISCHARGE_SUPPORTED: String;
    BATTERY_SYSTEM_BATTERY: String;
    Technology: String;
    Chemistry: String;
    DesignedCapacity: String;
    FullChargedCapacity: String;
    DefaultAlert1: String;
    DefaultAlert2: String;
    CriticalBias: String;
    CycleCount: String;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
    //   BatteryManufactureName
    BatteryManufactureName: String;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
    //   BatteryDeviceName
    BatteryDeviceName: String;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
    //   BatterySerialNumber
    BatterySerialNumber: String;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
    //   BatteryUniqueID
    BatteryUniqueID: String;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
    //   BatteryManufactureDate
    BatteryManufactureDate: String;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
    //   BatteryTemperature
    BatteryTemperature: String;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_STATUS
    PowerState: String;
    BATTERY_CHARGING: String;
    BATTERY_CRITICAL: String;
    BATTERY_DISCHARGING: String;
    BATTERY_POWER_ON_LINE: String;
    Capacity: String;
    Voltage: String;
    Rate: String;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
    //   BatteryEstimatedTime
    BatteryEstimatedTime: String;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
    //   BatteryGranularityInformation
    Entry: String;
    brsGranularity: Array[0..3] of String;
    brsCapacity: Array[0..3] of String;
    //
    BatteryChargeCompletionTime: String;
  end;

//
// obeڍ׏W߂\(f[^)
//
type
  TkmBattInfo = record
    // Create
    CreateFileError: DWORD;
    hBattery: THANDLE;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_TAG
    IOCTL_BATTERY_QUERY_TAG_RetBool: BOOL;
    IOCTL_BATTERY_QUERY_TAG_Error: DWORD;
    BatteryTag: ULONG;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
    //   BatteryInformation
    IOCTL_BATTERY_QUERY_INFORMATION_RetBool: BOOL;
    IOCTL_BATTERY_QUERY_INFORMATION_Error: DWORD;
    Capabilities: ULONG;
    Technology: UCHAR;
    Reserved: array [0..2] of UCHAR;
    Chemistry: array [0..3] of UCHAR;
    DesignedCapacity: ULONG;
    FullChargedCapacity: ULONG;
    DefaultAlert1: ULONG;
    DefaultAlert2: ULONG;
    CriticalBias: ULONG;
    CycleCount: ULONG;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
    //   BatteryManufactureName
    BatteryManufactureName_RetBool: BOOL;
    BatteryManufactureName_Error: DWORD;
    BatteryManufactureName: String;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
    //   BatteryDeviceName
    BatteryDeviceName_RetBool: BOOL;
    BatteryDeviceName_Error: DWORD;
    BatteryDeviceName: String;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
    //   BatterySerialNumber
    BatterySerialNumber_RetBool: BOOL;
    BatterySerialNumber_Error: DWORD;
    BatterySerialNumber: String;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
    //   BatteryUniqueID
    BatteryUniqueID_RetBool: BOOL;
    BatteryUniqueID_Error: DWORD;
    BatteryUniqueID: String;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
    //   BatteryManufactureDate
    BatteryManufactureDate_RetBool: BOOL;
    BatteryManufactureDate_Error: DWORD;
    BatteryManufactureDate: String;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
    //   BatteryTemperature
    BatteryTemperature_RetBool: BOOL;
    BatteryTemperature_Error: DWORD;
    BatteryTemperature: ULONG;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_STATUS
    IOCTL_BATTERY_QUERY_STATUS_RetBool: BOOL;
    IOCTL_BATTERY_QUERY_STATUS_Error: DWORD;
    PowerState: ULONG;
    Capacity: ULONG;
    Voltage: ULONG;
    Rate: LONG;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
    //   BatteryEstimatedTime
    BatteryEstimatedTime_RetBool: BOOL;
    BatteryEstimatedTime_Error: DWORD;
    BatteryEstimatedTime: ULONG;
    // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
    //   BatteryGranularityInformation
    BatteryGranularityInformation_RetBool: BOOL;
    BatteryGranularityInformation_Error: DWORD;
    Entry: Integer;
    brs: Array[0..3] of BATTERY_REPORTING_SCALE;
    // CloseHandle
    CloseHandle_RetBool: BOOL;
    CloseHandle_Error: DWORD;
  end;

type
  PBattInfo = ^TkmBattInfo;
  PBattInfoStr = ^TkmBattInfoStr;
  PTSystemPowerStatus = ^TSystemPowerStatus;

//
// 玩ꂽ\[X
//

type
  TForm1 = class(TForm)
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    Label44: TLabel;
    Label45: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    Label49: TLabel;
    Label50: TLabel;
    Label51: TLabel;
    Label52: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    Edit15: TEdit;
    Edit16: TEdit;
    Edit17: TEdit;
    Edit18: TEdit;
    Edit19: TEdit;
    Edit20: TEdit;
    Edit21: TEdit;
    Edit22: TEdit;
    Edit23: TEdit;
    Edit24: TEdit;
    Edit25: TEdit;
    Edit26: TEdit;
    Edit27: TEdit;
    Edit28: TEdit;
    Edit29: TEdit;
    Edit30: TEdit;
    Edit31: TEdit;
    Edit32: TEdit;
    Edit33: TEdit;
    Edit34: TEdit;
    Edit35: TEdit;
    Edit36: TEdit;
    Edit37: TEdit;
    Edit38: TEdit;
    Edit39: TEdit;
    Edit40: TEdit;
    Edit41: TEdit;
    Edit42: TEdit;
    Edit43: TEdit;
    Edit44: TEdit;
    Edit45: TEdit;
    Edit46: TEdit;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuFileSave: TMenuItem;
    MenuFileExit: TMenuItem;
    MenuAbout: TMenuItem;
    MenuAboutVersion: TMenuItem;
    MenuLanguage: TMenuItem;
    MenuLanguageJapanese: TMenuItem;
    MenuLanguageEnglish: TMenuItem;
    Button1: TButton;
    CheckBox1: TCheckBox;
    Timer1: TTimer;
    SaveDialog1: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure MenuLanguageJapaneseClick(Sender: TObject);
    procedure MenuLanguageEnglishClick(Sender: TObject);
    procedure MenuFileSaveClick(Sender: TObject);
    procedure MenuFileExitClick(Sender: TObject);
    procedure MenuAboutVersionClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure LanguageCheck(Jp: Boolean);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure WriteDebugString(InStr: String);
    //
    procedure EnumBattInfo();
    procedure ShowBattInfo();
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.dfm}

var
  BattNum: Integer;
  BatteryDevicePath: Array of String;
  BattInfo: TkmBattInfo;
  BattInfoStr: TkmBattInfoStr;
  EditArray: array [1..46] of TEdit;
  Jp: Boolean;

//
// fobOp̕\/O쐬
//
procedure TForm1.WriteDebugString(InStr: String);
var
  hFile: THandle;
  LL: Integer;
  II: Integer;
  lpNumberOfBytesWritten: DWORD;
  DebugLogBuffer: array[0..511] of Char;
  FullPath: String;
begin
  LL := Length(Instr);
  if LL > 512 then LL := 512;
  for II := 0 TO LL - 1 do begin
    DebugLogBuffer[II] := Instr[II + 1]
  end;
  FullPath := ExtractFileDir(Application.ExeName) + '\DebugLog.txt';
  hFile := CreateFile(PChar(FullPath), GENERIC_WRITE,
                      FILE_SHARE_READ + FILE_SHARE_WRITE, NIL,
                      OPEN_ALWAYS,
                      FILE_ATTRIBUTE_NORMAL, 0);
  SetFilePointer(hFile, 0, NIL, FILE_END);
  WriteFile(hFile, DebugLogBuffer, LL, lpNumberOfBytesWritten, nil);
  CloseHandle(hFile)
end;

//
// st@Co[W擾
// http://msdn.microsoft.com/library/ja/default.asp?url=/library/ja/jpwinui/html/_win32_verqueryvalue.asp
//
// ͌ĂȂBŏɌ̏擾
// ₢킹Ɏgpł镶͈ȉ̂Ƃ
//
// Comments, InternalName, ProductName,
// CompanyName, LegalCopyright, ProductVersion,
// FileDescription, LegalTrademarks, PrivateBuild,
// FileVersion, OriginalFilename, SpecialBuild
//
function GetVersionInfo(KeyWord: String): string;
var
  BufSize: DWORD;
  HWnd: DWORD;
  pBlock: Pointer;
  lpBuffer: Pointer;
  lpTemp: Pointer;
  dwBytes: Longword;
  II: DWORD;
begin
  result := '';
  // Kvȃobt@̃TCY𒲂ׂ
  BufSize := GetFileVersionInfoSize(PChar(Application.ExeName), HWnd);
  if BufSize > 0 then begin
    // m
    GetMem(pBlock, BufSize);
    try
      // pBlockwƂɃt@C̃o[W񃊃\[X擾
      GetFileVersionInfo(PChar(Application.ExeName), 0, BufSize, pBlock);
      // R[h擾
      VerQueryValue(pBlock, PChar('\VarFileInfo\Translation'),
                    lpBuffer, dwBytes);
      // R[h܂񂾖₢킹쐬
      // 816iɕϊ
      // '\StringFileInfo\hhhhhhhh\FileDescription'
      VerQueryValue(pBlock,
                    PChar('\StringFileInfo\' +
                    IntToHex(Integer(lpBuffer^) and $FFFF, 4) +
                    IntToHex((Integer(lpBuffer^) shr 16) and $FFFF, 4) +
                    '\' + KeyWord),
                    lpBuffer,
                    dwBytes);
      // dwBytes̐k܂ނǂ̖mȋLqȂ̂
      // dwBytes񐔃Rs[Ă݂ŌオNULLB
      II := 0;
      lpTemp := lpBuffer;
      while II < dwBytes do begin
        result := result + Char(lpTemp^);
        lpTemp := Pointer(Integer(lpTemp) + 1);
        II := II + 1
      end;
      // ̍ŌNulltĂ̂Ŏ
      result := Trim(Result)
    finally
      // 
      FreeMem(pBlock)
    end
  end
end;

//
// G[R[h𕶎ɕϊ
// G[R[hŕ\
//
function GetLastErrorStr(ErrorCode: Integer): String;
var
  LastErrorStr: Array[0..1024 - 1] of Char; // G[ԍ𕶎ɂ
begin
  FormatMessage(Format_Message_From_System, Nil, ErrorCode,
                (SubLang_Default shl 10) + Lang_Neutral,
                LastErrorStr, 1024, Nil);
  Result := '(' + IntToStr(ErrorCode) + ')' + LastErrorStr
end;

//
// bbɕϊ
//
function SecondsToHHMMSS(Seconds: DWORD): String;
var
  HH: Integer;
  MM: Integer;
  SS: Integer;
begin
  HH := Seconds div 3600;
  MM := (Seconds mod 3600) div 60;
  SS := Seconds mod 60;
  Result := Format('%2.2d:%2.2d:%2.2d', [HH, MM, SS])
end;

//
// GetSystemPowerStatus𕶎ɂ
//
procedure SystemPowerStatusToStr(Jp: Boolean;
                                 SystemPowerStatus1: PTSystemPowerStatus;
                                 SystemPowerStatusStr: PTkmSystemPowerStatus);
var
  ValidValueFlag: Boolean;
  strUnknown: String;
  strBattery: String;
  strAC: String;
  strUndefine: String;
  strHigh: String;
  strLow: String;
  strCritical: String;
  strCharging: String;
  strNormal: String;
  strNoSystemBattery: String;
begin
  if Jp then begin
    strUnknown := 's';
    strBattery := 'dr';
    strAC := 'ACd';
    strUndefine := '`';
    strHigh := '';
    strLow := '';
    strCritical := 'NeBJ';
    strCharging := '[d';
    strNormal := '';
    strNoSystemBattery := 'VXeEobe'
  end else begin
    strUnknown := 'Unknown';
    strBattery := 'Battery';
    strAC := 'AC';
    strUndefine := 'Undefine';
    strHigh := 'High';
    strLow := 'Low';
    strCritical := 'Critical';
    strCharging := 'Charging';
    strNormal := 'Normal';
    strNoSystemBattery := 'No system battery'
  end;
  if SystemPowerStatusStr.RetBool = False then begin
    SystemPowerStatusStr.ACLineStatus := strUnknown;
    SystemPowerStatusStr.BatteryFlag := strUnknown;
    SystemPowerStatusStr.BatteryFlagStr := strUnknown;
    SystemPowerStatusStr.BatteryLifePercent := strUnknown;
    SystemPowerStatusStr.Reserved := strUnknown;
    SystemPowerStatusStr.BatteryLifeTime := strUnknown;
    SystemPowerStatusStr.BatteryFullLifeTime := strUnknown
  end else begin
    case SystemPowerStatus1.ACLineStatus of
      0:
        SystemPowerStatusStr.ACLineStatus := strBattery;
      1:
        SystemPowerStatusStr.ACLineStatus := strAC;
      255:
        SystemPowerStatusStr.ACLineStatus := strUnknown;
      else
        SystemPowerStatusStr.ACLineStatus := strUndefine + '(' +
          IntToStr(SystemPowerStatus1.ACLineStatus) + ')'
    end;
    // BatteryFlag
    SystemPowerStatusStr.BatteryFlag :=
      '0x' + IntToHex(SystemPowerStatus1.BatteryFlag, 8);
    ValidValueFlag := False;
    if SystemPowerStatus1.BatteryFlag = 255 then begin
      SystemPowerStatusStr.BatteryFlagStr := strUnknown;
      ValidValueFlag := True
    end else begin
      SystemPowerStatusStr.BatteryFlagStr := '';
      if Boolean(SystemPowerStatus1.BatteryFlag and 1) then begin
        SystemPowerStatusStr.BatteryFlagStr := strHigh;
        ValidValueFlag := True
      end;
      if Boolean(SystemPowerStatus1.BatteryFlag and 2) then begin
        ValidValueFlag := True;
        if SystemPowerStatusStr.BatteryFlagStr <> '' then begin
          SystemPowerStatusStr.BatteryFlagStr := 
            SystemPowerStatusStr.BatteryFlagStr + '-'
        end;
        SystemPowerStatusStr.BatteryFlagStr :=
          SystemPowerStatusStr.BatteryFlagStr + strLow
      end;
      if Boolean(SystemPowerStatus1.BatteryFlag and 4) then begin
        ValidValueFlag := True;
        if SystemPowerStatusStr.BatteryFlagStr <> '' then begin
          SystemPowerStatusStr.BatteryFlagStr :=
            SystemPowerStatusStr.BatteryFlagStr + '-'
        end;
        SystemPowerStatusStr.BatteryFlagStr :=
          SystemPowerStatusStr.BatteryFlagStr + strCritical
      end;
      if Boolean(SystemPowerStatus1.BatteryFlag and 8) then begin
        ValidValueFlag := True;
        if SystemPowerStatusStr.BatteryFlagStr <> '' then begin
          SystemPowerStatusStr.BatteryFlagStr :=
            SystemPowerStatusStr.BatteryFlagStr + '-'
        end;
        SystemPowerStatusStr.BatteryFlagStr :=
          SystemPowerStatusStr.BatteryFlagStr + strCharging
      end;
      if Boolean(SystemPowerStatus1.BatteryFlag and 128) then begin
        ValidValueFlag := True;
        if SystemPowerStatusStr.BatteryFlagStr <> '' then begin
          SystemPowerStatusStr.BatteryFlagStr :=
            SystemPowerStatusStr.BatteryFlagStr + '-'
        end;
        SystemPowerStatusStr.BatteryFlagStr :=
          SystemPowerStatusStr.BatteryFlagStr + strNoSystemBattery
      end
    end;
    if ValidValueFlag = False then begin
      if SystemPowerStatus1.BatteryFlag = 0 then begin
        SystemPowerStatusStr.BatteryFlagStr := strNormal
      end else begin
        SystemPowerStatusStr.BatteryFlagStr := strUndefine + '(' +
                           IntToStr(SystemPowerStatus1.BatteryFlag) + ')'
      end
    end;
    // BatteryLifePercent 0-100, 255
    case SystemPowerStatus1.BatteryLifePercent of
    255:
      SystemPowerStatusStr.BatteryLifePercent := strUnknown;
    else
      SystemPowerStatusStr.BatteryLifePercent :=
        IntToStr(SystemPowerStatus1.BatteryLifePercent) + '[%]'
    end;
    // BatteryLifeTime
    // obe쓮̎c莞Ԃ̕bHHMMSSɊZ
    if SystemPowerStatus1.BatteryLifeTime = $FFFFFFFF then begin
      SystemPowerStatusStr.BatteryLifeTime := strUnknown
    end else begin
      SystemPowerStatusStr.BatteryLifeTime :=
        SecondsToHHMMSS(SystemPowerStatus1.BatteryLifeTime)
    end;
    // BatteryFullLifeTime
    if SystemPowerStatus1.BatteryFullLifeTime = $FFFFFFFF then begin
      SystemPowerStatusStr.BatteryFullLifeTime :=  strUnknown
    end else begin
      SystemPowerStatusStr.BatteryFullLifeTime :=
        SecondsToHHMMSS(SystemPowerStatus1.BatteryFullLifeTime)
    end
  end
end;

//
// obeڍ׏𐶂̂܂ܓǂݏo
//
procedure GetBattInfo(BatteryDevicePath: String; PBattInfo:TkmBattInfo);
var
  bqi: BATTERY_QUERY_INFORMATION;
  bi: BATTERY_INFORMATION;
  dwOut: DWORD;
  ii: Integer;
  dwWait: DWORD;
  ulEstimatedTime: ULONG;
  ReturnedBuff: Array[0..1023] of WideChar;
  ulBatteryTemperature: ULONG;
  bws: BATTERY_WAIT_STATUS;
  bs: BATTERY_STATUS;
  brs: Array[0..3] of BATTERY_REPORTING_SCALE;
  tempPtr: Pointer;
begin
  //
  // CreateFile
  //
  BattInfo.hBattery :=
    CreateFile(PChar(BatteryDevicePath),
                     GENERIC_READ or GENERIC_WRITE,
                     FILE_SHARE_READ or FILE_SHARE_WRITE,
                     nil,
                     OPEN_EXISTING,
                     FILE_ATTRIBUTE_NORMAL,
                     0);
  BattInfo.CreateFileError := GetLastError;
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_TAG
  //
  dwWait := 0;
  bqi.BatteryTag := 0;
  BattInfo.IOCTL_BATTERY_QUERY_TAG_RetBool :=
    DeviceIoControl(BattInfo.hBattery,
                    IOCTL_BATTERY_QUERY_TAG,
                    @dwWait,
                    SizeOf(dwWait),
                    @bqi.BatteryTag,
                    SizeOf(bqi.BatteryTag),
                    @dwOut,
                    nil);
  BattInfo.IOCTL_BATTERY_QUERY_TAG_Error := GetLastError;
//  BattInfo.IOCTL_BATTERY_QUERY_TAG_RetBool := False; // mFp
  BattInfo.BatteryTag := bqi.BatteryTag;
//  BattInfo.BatteryTag := 4294967295; // mFp
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
  // BatteryInformation
  //
  // DeviceIoControl ĂяoƃG[87(p[^܂)
  // Ȃ邱ƂBp^͐B
  // ׂ@bqi̒l$12FCB8ƃG[C$12FCB4OK
  // ǂACĝ̖悤BƂ肠|C^ɑ
  // 삷悤ɂȂB
  //
  bi.Capabilities := 0;
  bi.Technology := 0;
  bi.Reserved[0] := 0;
  bi.Reserved[1] := 0;
  bi.Reserved[2] := 0;
  bi.Chemistry[0] := 0;
  bi.Chemistry[1] := 0;
  bi.Chemistry[2] := 0;
  bi.Chemistry[3] := 0;
  bi.DesignedCapacity := 0;
  bi.FullChargedCapacity := 0;
  bi.DefaultAlert1 := 0;
  bi.DefaultAlert2 := 0;
  bi.CriticalBias := 0;
  bi.CycleCount := 0;
  bqi.InformationLevel := BatteryInformation;
  tempPtr := @bqi;              // \̂̃ACg(?)̕s
                                // J
  BattInfo.IOCTL_BATTERY_QUERY_INFORMATION_RetBool :=
    DeviceIoControl(BattInfo.hBattery,
                    IOCTL_BATTERY_QUERY_INFORMATION,
                    tempPtr,    // \̂̃ACg(?)̕s
                                // J
                    SizeOf(bqi),
                    @bi,
                    SizeOf(bi),
                    @dwOut,
                    nil);
//  BattInfo.IOCTL_BATTERY_QUERY_INFORMATION_RetBool := False; // mFp
  BattInfo.IOCTL_BATTERY_QUERY_INFORMATION_Error := GetLastError;
  BattInfo.Capabilities := bi.Capabilities;
//  BattInfo.Capabilities := $80000000; // mFp
  BattInfo.Technology := bi.Technology;
//  BattInfo.Technology := 2; // mFp
  for ii := 0 to 3 do begin
    BattInfo.Chemistry[ii] := bi.Chemistry[ii]
  end;
//  BattInfo.Chemistry[0] := Byte('A'); // mFp
//  BattInfo.Chemistry[1] := Byte('B'); // mFp
//  BattInfo.Chemistry[2] := Byte('C'); // mFp
//  BattInfo.Chemistry[3] := Byte('D'); // mFp
  BattInfo.DesignedCapacity := bi.DesignedCapacity;
//  BattInfo.DesignedCapacity := 4294967295; // mFp
  BattInfo.FullChargedCapacity := bi.FullChargedCapacity;
//  BattInfo.FullChargedCapacity := 4294967295; // mFp
  BattInfo.DefaultAlert1 := bi.DefaultAlert1;
//  BattInfo.DefaultAlert1 := 4294967295; // mFp
  BattInfo.DefaultAlert2 := bi.DefaultAlert2;
//  BattInfo.DefaultAlert2 := 4294967295; // mFp
  BattInfo.CriticalBias := bi.CriticalBias;
//  BattInfo.CriticalBias := 4294967295; // mFp
  BattInfo.CycleCount := bi.CycleCount;
//  BattInfo.CycleCount := 4294967295; // mFp
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
  //   BatteryManufactureName
  //
  bqi.InformationLevel := BatteryManufactureName;
  BattInfo.BatteryManufactureName_RetBool :=
    DeviceIoControl(BattInfo.hBattery,
                    IOCTL_BATTERY_QUERY_INFORMATION,
                    @bqi,
                    SizeOf(bqi),
                    @ReturnedBuff,
                    1024,
                    @dwOut,
                    nil);
//  BattInfo.BatteryManufactureName_RetBool := False; // mFp
  BattInfo.BatteryManufactureName_Error := GetLastError;
//  ReturnedBuff[0] := 'A'; // mFp
//  ReturnedBuff[1] := 'B'; // mFp
//  ReturnedBuff[2] := 'C'; // mFp
//  ReturnedBuff[3] := 'D'; // mFp
//  dwOut := 8; // mFp
  BattInfo.BatteryManufactureName := '';
  for ii := 0 to dwOut div 2 - 1 do begin
    BattInfo.BatteryManufactureName := BattInfo.BatteryManufactureName +
                                       ReturnedBuff[ii]
  end;
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
  //   BatteryDeviceName
  //
  bqi.InformationLevel := BatteryDeviceName;
  BattInfo.BatteryDeviceName_RetBool :=
    DeviceIoControl(BattInfo.hBattery,
                    IOCTL_BATTERY_QUERY_INFORMATION,
                    @bqi,
                    SizeOf(bqi),
                    @ReturnedBuff,
                    1024,
                    @dwOut,
                    nil);
//  BattInfo.BatteryDeviceName_RetBool := False; // mFp
  BattInfo.BatteryDeviceName_Error := GetLastError;
//  ReturnedBuff[0] := 'A'; // mFp
//  ReturnedBuff[1] := 'B'; // mFp
//  ReturnedBuff[2] := 'C'; // mFp
//  ReturnedBuff[3] := 'D'; // mFp
//  dwOut := 8; // mFp
  BattInfo.BatteryDeviceName := '';
  for ii := 0 to dwOut div 2 - 1 do begin
    BattInfo.BatteryDeviceName := BattInfo.BatteryDeviceName +
                                       ReturnedBuff[ii]
  end;
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
  //   BatterySerialNumber
  //
  bqi.InformationLevel := BatterySerialNumber;
  BattInfo.BatterySerialNumber_RetBool :=
    DeviceIoControl(BattInfo.hBattery,
                    IOCTL_BATTERY_QUERY_INFORMATION,
                    @bqi,
                    SizeOf(bqi),
                    @ReturnedBuff,
                    1024,
                    @dwOut,
                    nil);
//  BattInfo.BatterySerialNumber_RetBool := True; // mFp
  BattInfo.BatterySerialNumber_Error := GetLastError;
//  ReturnedBuff[0] := 'A'; // mFp
//  ReturnedBuff[1] := 'B'; // mFp
//  ReturnedBuff[2] := 'C'; // mFp
//  ReturnedBuff[3] := 'D'; // mFp
//  dwOut := 8; // mFp
  BattInfo.BatterySerialNumber := '';
  for ii := 0 to dwOut div 2 - 1 do begin
    BattInfo.BatterySerialNumber := BattInfo.BatterySerialNumber +
                                       ReturnedBuff[ii]
  end;
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
  //   BatteryUniqueID
  //
  bqi.InformationLevel := BatteryUniqueID;
  BattInfo.BatteryUniqueID_RetBool :=
    DeviceIoControl(BattInfo.hBattery,
                    IOCTL_BATTERY_QUERY_INFORMATION,
                    @bqi,
                    SizeOf(bqi),
                    @ReturnedBuff,
                    1024,
                    @dwOut,
                    nil);
//  BattInfo.BatteryUniqueID_RetBool := False;
  BattInfo.BatteryUniqueID_Error := GetLastError;
//  ReturnedBuff[0] := 'A'; // mFp
//  ReturnedBuff[1] := 'B'; // mFp
//  ReturnedBuff[2] := 'C'; // mFp
//  ReturnedBuff[3] := 'D'; // mFp
//  dwOut := 8; // mFp
  BattInfo.BatteryUniqueID := '';
  for ii := 0 to dwOut div 2 - 1 do begin
    BattInfo.BatteryUniqueID := BattInfo.BatteryUniqueID +
                                       ReturnedBuff[ii]
  end;
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
  //   BatteryManufacutureDate
  //
  bqi.InformationLevel := BatteryManufactureDate;
  BattInfo.BatteryManufactureDate_RetBool :=
    DeviceIoControl(BattInfo.hBattery,
                    IOCTL_BATTERY_QUERY_INFORMATION,
                    @bqi,
                    SizeOf(bqi),
                    @ReturnedBuff,
                    1024,
                    @dwOut,
                    nil);
//  BattInfo.BatteryManufactureDate_RetBool := True;
  BattInfo.BatteryManufactureDate_Error := GetLastError;
//  ReturnedBuff[0] := 'A'; // mFp
//  ReturnedBuff[1] := 'B'; // mFp
//  ReturnedBuff[2] := 'C'; // mFp
//  ReturnedBuff[3] := 'D'; // mFp
//  dwOut := 8; // mFp
  BattInfo.BatteryManufactureDate := '';
  for ii := 0 to dwOut div 2 - 1 do begin
    BattInfo.BatteryManufactureDate := BattInfo.BatteryManufactureDate +
                                       ReturnedBuff[ii]
  end;
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
  //   BatteryTemperature
  //
  bqi.InformationLevel := BatteryTemperature;
  BattInfo.BatteryTemperature_RetBool :=
    DeviceIoControl(BattInfo.hBattery,
                    IOCTL_BATTERY_QUERY_INFORMATION,
                    @bqi,
                    SizeOf(bqi),
                    @ulBatteryTemperature,
                    SizeOf(BatteryTemperature),
                    @dwOut,
                    nil);
//  BattInfo.BatteryTemperature_RetBool := True;
  BattInfo.BatteryTemperature_Error := GetLastError;
  BattInfo.BatteryTemperature := ulBatteryTemperature;
//  BattInfo.BatteryTemperature := 3000;
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_STATUS
  //
  bws.BatteryTag := bqi.BatteryTag;
  bws.Timeout := 0;
  bws.PowerState := 0;
  bws.LowCapacity := 0;
  bws.HighCapacity := 0;
  //
  bs.PowerState := 0;
  bs.Capacity := 0;
  bs.Voltage := 0;
  bs.Rate := 0;
  //
  BattInfo.IOCTL_BATTERY_QUERY_STATUS_RetBool :=
    DeviceIoControl(BattInfo.hBattery,
                    IOCTL_BATTERY_QUERY_STATUS,
                    @bws,
                    SizeOf(bws),
                    @bs,
                    SizeOf(bs),
                    @dwOut,
                    nil);
//  BattInfo.IOCTL_BATTERY_QUERY_STATUS_RetBool := False; // mFp
  BattInfo.IOCTL_BATTERY_QUERY_STATUS_Error := GetLastError;
  BattInfo.PowerState := bs.PowerState;
//  BattInfo.PowerState := 8; // mFp
  BattInfo.Capacity := bs.Capacity;
//  BattInfo.Capacity := 4294967295; // mFp
  BattInfo.Voltage := bs.Voltage;
//  BattInfo.Voltage := 4294967295; // mFp
  BattInfo.Rate := bs.Rate;
//  BattInfo.Rate := -2147483647; // mFp
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
  // BatteryEstimatedTime
  //
  bqi.InformationLevel := BatteryEstimatedTime;
  bqi.AtRate := bs.Rate;
  BattInfo.BatteryEstimatedTime_RetBool :=
    DeviceIoControl(BattInfo.hBattery,
                    IOCTL_BATTERY_QUERY_INFORMATION,
                    @bqi,
                    SizeOf(bqi),
                    @ulEstimatedTime,
                    SizeOf(ulEstimatedTime),
                    @dwOut,
                    nil);
//  BattInfo.BatteryEstimatedTime_RetBool := False; // mFp
  BattInfo.BatteryEstimatedTime_Error := GetLastError;
  BattInfo.BatteryEstimatedTime := ulEstimatedTime;
// BattInfo.BatteryEstimatedTime := 36000; // mFp
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
  //   BatteryGranularityInformation
  //
  bqi.InformationLevel := BatteryGranularityInformation;
  BattInfo.BatteryGranularityInformation_RetBool :=
    DeviceIoControl(BattInfo.hBattery,
                    IOCTL_BATTERY_QUERY_INFORMATION,
                    @bqi,
                    SizeOf(bqi),
                    @brs,
                    SizeOf(brs),
                    @dwOut,
                    nil);
//  BattInfo.BatteryGranularityInformation_RetBool := False; // mFp
  BattInfo.BatteryGranularityInformation_Error := GetLastError;
//  dwOut := 32;
//  brs[0].Granularity := 1234; // mFp
//  brs[0].Capacity := 5678; // mFp
//  brs[1].Granularity := 4294967295; // mFp
//  brs[1].Capacity := 4294967295; // mFp
//  brs[2].Granularity := 4294967295; // mFp
//  brs[2].Capacity := 4294967295; // mFp
//  brs[3].Granularity := 4294967295; // mFp
//  brs[3].Capacity := 4294967295; // mFp
  if BattInfo.BatteryGranularityInformation_RetBool then begin
    BattInfo.Entry := dwOut div SizeOf(BATTERY_REPORTING_SCALE)
  end else begin
    BattInfo.Entry := 0
  end;
  for ii := 0 to 3 do begin
    BattInfo.brs[ii].Granularity := brs[ii].Granularity;
    BattInfo.brs[ii].Capacity := brs[ii].Capacity
  end;
  //
  // CloseHandle
  //
  BattInfo.CloseHandle_RetBool := CloseHandle(BattInfo.hBattery);
  BattInfo.CloseHandle_Error := GetLastError
end;

//
// f[^eLXgt@Cɂ
// ̂ƂɃG[E`FbNs
//
procedure BattInfoToStr(Jp: Boolean; PBattInfo: TkmBattInfo;
                        PBattInfoStr: TkmBattInfoStr);
var
  ii: Integer;
  strUnknown: String;
  strUndefined: String;
  strYes: String;
  strNo: String;
  strNonrechargeableBattery: String;
  strRechargeableBattery: String;
  strNoSystemBattery: String;
  strNotSupported: String;
begin
  if Jp then begin
    strUnknown := 's';
    strUndefined := '`';
    strYes := '͂';
    strNo := '';
    strNonrechargeableBattery := 'ꎟdr';
    strRechargeableBattery := '񎟓dr';
    strNoSystemBattery := 'VXeEobe';
    strNotSupported := 'T|[g'
  end else begin
    strUnknown := 'Unknown';
    strUndefined := 'Undefined';
    strYes := 'Yes';
    strNo := 'No';
    strNonrechargeableBattery := 'Nonrechargeable battery';
    strRechargeableBattery := 'Rechargeable battery';
    strNoSystemBattery := 'No system battery';
    strNotSupported := 'Not supported'
  end;
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_TAG
  //
  if ULONG(BattInfo.IOCTL_BATTERY_QUERY_TAG_RetBool) = 0 then begin
    BattInfoStr.BatteryTag := strUnknown
  end else begin
    BattInfoStr.BatteryTag := IntToStr(BattInfo.BatteryTag)
  end;
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
  // BatteryInformation
  //
  if ULONG(BattInfo.IOCTL_BATTERY_QUERY_INFORMATION_RetBool) = 0 then begin
    BattInfoStr.Capabilities := strUnknown;
    BattInfoStr.BATTERY_CAPACITY_RELATIVE := strUnknown;
    BattInfoStr.BATTERY_IS_SHORT_TERM := strUnknown;
    BattInfoStr.BATTERY_SET_CHARGE_SUPPORTED := strUnknown;
    BattInfoStr.BATTERY_SET_DISCHARGE_SUPPORTED := strUnknown;
    BattInfoStr.BATTERY_SYSTEM_BATTERY := strUnknown;
    BattInfoStr.Technology := strUnknown;
    BattInfoStr.Chemistry := strUnknown;
    BattInfoStr.DesignedCapacity := strUnknown;
    BattInfoStr.FullChargedCapacity := strUnknown;
    BattInfoStr.DefaultAlert1 := strUnknown;
    BattInfoStr.DefaultAlert2 := strUnknown;
    BattInfoStr.CriticalBias := strUnknown;
    BattInfoStr.CycleCount := strUnknown;
    BattInfoStr.BatteryChargeCompletiontime := strUnknown
  end else begin
    BattInfoStr.Capabilities := '0x' + IntToHex(BattInfo.Capabilities, 8);
    if (BattInfo.Capabilities and BATTERY_CAPACITY_RELATIVE) <> 0
      then begin
      BattInfoStr.BATTERY_CAPACITY_RELATIVE := strYes
    end else begin
      BattInfoStr.BATTERY_CAPACITY_RELATIVE := strNo
    end;
    if (BattInfo.Capabilities and BATTERY_IS_SHORT_TERM) <> 0 then begin
      BattInfoStr.BATTERY_IS_SHORT_TERM := strYes
    end else begin
      BattInfoStr.BATTERY_IS_SHORT_TERM := strNo
    end;
    if (BattInfo.Capabilities and BATTERY_SET_CHARGE_SUPPORTED) <> 0 then begin
      BattInfoStr.BATTERY_SET_CHARGE_SUPPORTED := strYes
    end else begin
      BattInfoStr.BATTERY_SET_CHARGE_SUPPORTED := strNo
    end;
    if (BattInfo.Capabilities and BATTERY_SET_DISCHARGE_SUPPORTED) <> 0
      then begin
      BattInfoStr.BATTERY_SET_DISCHARGE_SUPPORTED := strYes
    end else begin
      BattInfoStr.BATTERY_SET_DISCHARGE_SUPPORTED := strNo
    end;
    if (BattInfo.Capabilities and BATTERY_SYSTEM_BATTERY) <> 0 then begin
      BattInfoStr.BATTERY_SYSTEM_BATTERY := strYes
    end else begin
      BattInfoStr.BATTERY_SYSTEM_BATTERY := strNo
    end;
    case BattInfo.Technology of
    0:
      BattInfoStr.Technology := strNonrechargeableBattery;
    1:
      BattInfoStr.Technology := strRechargeableBattery;
    else
      BattInfoStr.Technology := strUndefined + '(' +
                                IntToStr(BattInfo.Technology) + ')'
    end;
    BattInfoStr.Chemistry := '';
    for ii := 0 to 3 do begin
      BattInfoStr.Chemistry := BattInfoStr.Chemistry +
                               Char(BattInfo.Chemistry[ii])
    end;
    BattInfoStr.DesignedCapacity := IntToStr(BattInfo.DesignedCapacity) +
                                    '[mWh]';
    BattInfoStr.FullChargedCapacity :=
      IntToStr(BattInfo.FullChargedCapacity) + '[mWh]';
    BattInfoStr.DefaultAlert1 := IntToStr(BattInfo.DefaultAlert1) + '[mWh]';
    BattInfoStr.DefaultAlert2 := IntToStr(BattInfo.DefaultAlert2) + '[mWh]';
    BattInfoStr.CriticalBias := IntToStr(BattInfo.CriticalBias) + '[mWh]';
    if BattInfo.CycleCount = 0 then begin
      BattInfoStr.CycleCount := strNotSupported
    end else begin
      BattInfoStr.CycleCount := IntToStr(BattInfo.CycleCount)
    end
  end;
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
  //   BatteryManufactureName
  //
  if ULONG(BattInfo.BatteryManufactureName_RetBool) = 0 then begin
    BattInfoStr.BatteryManufactureName := strUnknown
  end else begin
    BattInfoStr.BatteryManufactureName := BattInfo.BatteryManufactureName
  end;
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
  //   BatteryDeviceName
  //
  if ULONG(BattInfo.BatteryDeviceName_RetBool) = 0 then begin
    BattInfoStr.BatteryDeviceName := strUnknown
  end else begin
    BattInfoStr.BatteryDeviceName := BattInfo.BatteryDeviceName
  end;
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
  //   BatterySerialNumber
  //
  if ULONG(BattInfo.BatterySerialNumber_RetBool) = 0 then begin
    BattInfoStr.BatterySerialNumber := strUnknown
  end else begin
    BattInfoStr.BatterySerialNumber := BattInfo.BatterySerialNumber
  end;
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
  //   BatteryUniqueID
  //
  if ULONG(BattInfo.BatteryUniqueID_RetBool) = 0 then begin
    BattInfoStr.BatteryUniqueID := strUnknown
  end else begin
    BattInfoStr.BatteryUniqueID := BattInfo.BatteryUniqueID
  end;
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
  //   BatteryManufacutureDate
  //
  if ULONG(BattInfo.BatteryManufactureDate_RetBool) = 0 then begin
    BattInfoStr.BatteryManufactureDate := strUnknown
  end else begin
    BattInfoStr.BatteryManufactureDate := BattInfo.BatteryManufactureDate
  end;
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
  //   BatteryTemperature
  //
  if ULONG(BattInfo.BatteryTemperature_RetBool) = 0 then begin
    BattInfoStr.BatteryTemperature := strUnknown
  end else begin
    BattInfoStr.BatteryTemperature :=
      Format('%4.1f', [(Integer(BattInfo.BatteryTemperature - 2732)) / 10]) +
             '[C]'
  end;
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_STATUS
  //
  if ULONG(BattInfo.IOCTL_BATTERY_QUERY_STATUS_RetBool) = 0 then begin
    BattInfoStr.PowerState := strUnknown;
    BattInfoStr.BATTERY_CHARGING := strUnknown;
    BattInfoStr.BATTERY_CRITICAL := strUnknown;
    BattInfoStr.BATTERY_DISCHARGING := strUnknown;
    BattInfoStr.BATTERY_POWER_ON_LINE := strUnknown;
    BattInfoStr.Capacity := strUnknown;
    BattInfoStr.Voltage := strUnknown;
    BattInfoStr.Rate := strUnknown
  end else begin
    BattInfoStr.PowerState := '0x' + IntToHex(BattInfo.PowerState, 8);
    if (BattInfo.PowerState and BATTERY_CHARGING) <> 0 then begin
      BattInfoStr.BATTERY_CHARGING := strYes
    end else begin
      BattInfoStr.BATTERY_CHARGING := strNo
    end;
    if (BattInfo.PowerState and BATTERY_CRITICAL) <> 0 then begin
      BattInfoStr.BATTERY_CRITICAL := strYes
    end else begin
      BattInfoStr.BATTERY_CRITICAL := strNo
    end;
    if (BattInfo.PowerState and BATTERY_DISCHARGING) <> 0 then begin
      BattInfoStr.BATTERY_DISCHARGING := strYes
    end else begin
      BattInfoStr.BATTERY_DISCHARGING := strNo
    end;
    if (BattInfo.PowerState and BATTERY_POWER_ON_LINE) <> 0 then begin
      BattInfoStr.BATTERY_POWER_ON_LINE := strYes
    end else begin
      BattInfoStr.BATTERY_POWER_ON_LINE := strNo
    end;
    BattInfoStr.Capacity := IntToStr(BattInfo.Capacity) + '[mWh]';
    BattInfoStr.Voltage := IntToStr(BattInfo.Voltage) + '[mV]';
    if BattInfo.Rate = LONG(BATTERY_UNKNOWN_RATE) then begin
      BattInfoStr.Rate := strUnknown
    end else begin
      BattInfoStr.Rate := IntToStr(BattInfo.Rate) + '[mWh]'
    end
  end;
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
  // BatteryEstimatedTime
  //
  if ULONG(BattInfo.BatteryEstimatedTime_RetBool) = 0 then begin
    BattInfoStr.BatteryEstimatedTime := strUnknown
  end else begin
    if BattInfo.BatteryEstimatedTime = $FFFFFFFF then begin
      BattInfoStr.BatteryEstimatedTime := strUnknown
    end else begin
      BattInfoStr.BatteryEstimatedTime := 
        SecondsToHHMMSS(BattInfo.BatteryEstimatedTime)
    end
  end;
  //
  // DeviceIoControl - IOCTL_BATTERY_QUERY_INFORMATION
  //   BatteryGranularityInformation
  //
  if ULONG(BattInfo.BatteryGranularityInformation_RetBool) = 0 then begin
    BattInfoStr.Entry := strUnknown;
    for ii := 0 to 3 do begin
      BattInfoStr.brsGranularity[ii] := '';
      BattInfoStr.brsCapacity[ii] := ''
    end;
  end else begin
    BattInfoStr.Entry := IntToStr(BattInfo.Entry);
    for ii := 0 to 3 do begin
      BattInfoStr.brsGranularity[ii] := '';
      BattInfoStr.brsCapacity[ii] := ''
    end;
    for ii := 0 to BattInfo.Entry - 1 do begin
      BattInfoStr.brsGranularity[ii] :=
        IntToStr(BattInfo.brs[ii].Granularity) + '[mWh]';
      BattInfoStr.brsCapacity[ii] :=
        IntToStr(BattInfo.brs[ii].Capacity) + '[mWh]'
    end
  end;
  //
  if (ULONG(BattInfo.IOCTL_BATTERY_QUERY_STATUS_RetBool) = 0) or
    (BattInfo.Rate = LONG(BATTERY_UNKNOWN_RATE)) or
    (BattInfo.Rate <= 0) then begin
    BattInfoStr.BatteryChargeCompletiontime := strUnknown
  end else begin
    BattInfoStr.BatteryChargeCompletiontime :=
      SecondsToHHMMSS((3600 * (Integer(BattInfo.FullChargedCapacity) -
                     Integer(BattInfo.Capacity))) div BattInfo.Rate)
  end
end;

//
// VXeɂobe񋓂
//
procedure TForm1.EnumBattInfo();
var
  hBattDevInfo: HDEVINFO;
  RetBool: Boolean;
  DeviceInterfaceData: SP_DEVICE_INTERFACE_DATA;
  RequiredSize: DWORD;
  DevicePathStr: String;
  PDeviceInformationDetailData: PSP_DEVICE_INTERFACE_DETAIL_DATA;
  ii: Integer;
begin
  //
  // obeɊւZbg̃nh擾
  //
  hBattDevInfo := SetupDiGetClassDevs(@GUID_DEVICE_BATTERY,
                                      nil,
                                      Handle,
                                      DIGCF_PRESENT or DIGCF_DEVICEINTERFACE);
  BattNum := 0;
  while True do begin
    //
    // obeɊւfoCXZbg̃foCXEC^tF[X\
    // ReLXg\̂߂
    //
    DeviceInterfaceData.cbSize := SizeOf(DeviceInterfaceData);
    RetBool := SetupDiEnumDeviceInterfaces(hBattDevInfo,
                                           nil,
                                           @GUID_DEVICE_BATTERY,
                                           BattNum,
                                           @DeviceInterfaceData);
    if not RetBool then begin
      break
    end;
    //
    // obẽfoCXEC^tF[XɊւڍ׏߂邽߂
    // ̈̑傫₢킹
    //
    SetupDiGetDeviceInterfaceDetail(hBattDevInfo,
                                    @DeviceInterfaceData,
                                    nil,
                                    0,
                                    @RequiredSize,
                                    nil);
    //
    // Kvȗ̈m
    //
    PDeviceInformationDetailData :=
      AllocMem(RequiredSize + sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA));
    //
    // obẽfoCXEC^tF[XɊւڍ׏߂
    // ŋJBcbSize̒l5łKvB
    // The cbSize member always contains the size of the fixed part of the
    // data structure, not a size reflecting the variable-length string at
    // the end. ďĂ 4낤ɁcB
    //
    PDeviceInformationDetailData.cbSize :=
      sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);
    SetupDiGetDeviceInterfaceDetail(hBattDevInfo,
                                    @DeviceInterfaceData,
                                    PDeviceInformationDetailData,
                                    RequiredSize,
                                    @RequiredSize, // msdn
                                    nil);
    DevicePathStr := PChar(@PDeviceInformationDetailData^.DevicePath); // ()
    //
    // ̈
    //
    FreeMem(PDeviceInformationDetailData);
//    if ShowDebugInfo then begin
//      Memo1.Lines.Add('DevicePath: ' + DevicePathStr);
//      Memo1.Lines.Add('=================')
//    end;
    BattNum := BattNum + 1;
    SetLength(BatteryDevicePath, BattNum);
    BatteryDevicePath[BattNum - 1] := DevicePathStr;
    Application.processmessages // Ô
  end;
  for ii := 0 to BattNum -1 do begin
    ComboBox1.Items.Add(IntToStr(ii) + ': ' + BatteryDevicePath[ii])
  end;
  ComboBox1.ItemIndex := 0;
  SetupDiDestroyDeviceInfoList(hBattDevInfo)
end;

//
// w肳ꂽ1̃obȅ\
//
procedure TForm1.ShowBattInfo();
var
  SystemPowerStatus1: TSystemPowerStatus;
  SystemPowerStatusStr: TkmSystemPowerStatusStr;
  ii: Integer;
begin
  for ii := 1 to Length(EditArray) do begin
    EditArray[ii].Text := ''
  end;
  if ComboBox1.Items.Count = 0 then begin
//    Memo1.Lines.Add('No system battery');
  end else begin
    GetBattInfo(BatteryDevicePath[ComboBox1.ItemIndex], BattInfo);
    BattInfoToStr(Jp, BattInfo, BattInfoStr);
//    Memo1.Lines.Clear;
    Edit1.Text := BattInfoStr.BatteryTag;
    Edit2.Text := BattInfoStr.Capabilities;
    Edit3.Text := BattInfoStr.BATTERY_CAPACITY_RELATIVE;
    Edit4.Text := BattInfoStr.BATTERY_IS_SHORT_TERM;
    Edit5.Text := BattInfoStr.BATTERY_SET_CHARGE_SUPPORTED;
    Edit6.Text := BattInfoStr.BATTERY_SET_DISCHARGE_SUPPORTED;
    Edit7.Text := BattInfoStr.BATTERY_SYSTEM_BATTERY;
    Edit8.Text := BattInfoStr.Technology;
    Edit9.Text := BattInfoStr.Chemistry;
    Edit10.Text := BattInfoStr.DesignedCapacity;
    Edit11.Text := BattInfoStr.FullChargedCapacity;
    Edit12.Text := BattInfoStr.DefaultAlert1;
    Edit13.Text := BattInfoStr.DefaultAlert2;
    Edit14.Text := BattInfoStr.CriticalBias;
    Edit15.Text := BattInfoStr.CycleCount;
    Edit29.Text := BattInfoStr.BatteryManufactureName;
    Edit27.Text := BattInfoStr.BatteryDeviceName;
    Edit31.Text := BattInfoStr.BatterySerialNumber;
    Edit30.Text := BattInfoStr.BatteryUniqueID;
    Edit28.Text := BattInfoStr.BatteryManufactureDate;
    Edit25.Text := BattInfoStr.BatteryTemperature;
    Edit32.Text := BattInfoStr.PowerState;
    Edit33.Text := BattInfoStr.BATTERY_CHARGING;
    Edit34.Text := BattInfoStr.BATTERY_CRITICAL;
    Edit35.Text := BattInfoStr.BATTERY_DISCHARGING;
    Edit36.Text := BattInfoStr.BATTERY_POWER_ON_LINE;
    Edit37.Text := BattInfoStr.Capacity;
    Edit38.Text := BattInfoStr.Voltage;
    Edit39.Text := BattInfoStr.Rate;
    Edit26.Text := BattInfoStr.BatteryEstimatedTime;
    Edit16.Text := BattInfoStr.Entry;
    Edit17.Text := BattInfoStr.brsGranularity[0];
    Edit18.Text := BattInfoStr.brsCapacity[0];
    Edit19.Text := BattInfoStr.brsGranularity[1];
    Edit20.Text := BattInfoStr.brsCapacity[1];
    Edit21.Text := BattInfoStr.brsGranularity[2];
    Edit22.Text := BattInfoStr.brsCapacity[2];
    Edit23.Text := BattInfoStr.brsGranularity[3];
    Edit24.Text := BattInfoStr.brsCapacity[3];
    SystemPowerStatusStr.RetBool := GetSystemPowerStatus(SystemPowerStatus1);
//  SystemPowerStatusStr.RetBool := False; // mFp
//  SystemPowerStatus1.ACLineStatus := 255; // mFp
//  SystemPowerStatus1.BatteryFlag := 254; // mFp
//  SystemPowerStatus1.BatteryLifePercent := 255; // mFp
//  SystemPowerStatus1.BatteryLifeTime := 36000; // mFp
//  SystemPowerStatus1.BatteryFullLifeTime := 5025; // mFp
    SystemPowerStatusToStr(Jp, @SystemPowerStatus1, @SystemPowerStatusStr);
    Edit40.Text := SystemPowerStatusStr.ACLineStatus;
    Edit41.Text := SystemPowerStatusStr.BatteryFlag;
    Edit42.Text := SystemPowerStatusStr.BatteryFlagStr;
    Edit43.Text :=SystemPowerStatusStr.BatteryLifePercent;
    Edit44.Text :=SystemPowerStatusStr.BatteryLifeTime;
    Edit45.Text :=SystemPowerStatusStr.BatteryFullLifeTime;
    Edit46.Text := BattInfoStr.BatteryChargeCompletionTime
  end
  // debug
//  WriteDebugString('Rate: ' + IntToHex(BattInfo.Rate, 8) + #$D + #$A);
//  WriteDebugString('Rate: ' + Edit39.Text + #$D + #$A);
//  WriteDebugString('EstimatedTime: ' +
//                   IntToHex(BattInfo.BatteryEstimatedTime, 8) + #$D + #$A);
//  WriteDebugString('EstimatedTime: ' +
//                   Edit26.Text + #$D + #$A);
end;

//
// ؊
//

procedure TForm1.LanguageCheck(Jp: Boolean);
begin
  if Jp then begin
    MenuLanguageJapanese.Checked := True;
    MenuLanguageEnglish.Checked := False;
    MenuFile.Caption := 't@C(&F)';
    MenuFileSave.Caption := 'ۑ(&S)';
    MenuFileExit.Caption := '(&X)';
    MenuLanguage.Caption := '(&L)';
    MenuLanguageJapanese.Caption := '{(&J)';
    MenuLanguageEnglish.Caption := 'p(&E)';
    MenuAbout.Caption := 'AoEg(&A)';
    MenuAboutVersion.Caption := 'o[W(&V)';
    Label2.Caption := 'obeE^O:';
    Label4.Caption := '\(16i\):';
    Label5.Caption := 'obeeʑΕ\:';
    Label6.Caption := 'Zԗpobe:';
    Label7.Caption := 'obe[dv:';
    Label8.Caption := 'obedv:';
    Label9.Caption := 'VXeEobe:';
    Label10.Caption := 'ꎟ/񎟓dr:';
    Label11.Caption := 'obe:';
    Label12.Caption := '݌ve:';
    Label13.Caption := 'te:';
    Label14.Caption := 'NeBJEA[e:';
    Label15.Caption := 'EEA[e:';
    Label16.Caption := 'NeBJEoCAX:';
    Label17.Caption := 'TCNEJEg:';
    Label19.Caption := 'xڐ:';
    Label20.Caption := 'x(0):';
    Label21.Caption := 'e(0):';
    Label22.Caption := 'x(1):';
    Label23.Caption := 'e(1):';
    Label24.Caption := 'x(2):';
    Label25.Caption := 'e(2):';
    Label26.Caption := 'x(3):';
    Label27.Caption := 'e(3):';
    Label29.Caption := 'obex:';
    Label30.Caption := 'c:';
    Label31.Caption := 'foCX:';
    Label32.Caption := ':';
    Label33.Caption := ':';
    Label34.Caption := 'j[NID:';
    Label35.Caption := 'obeEVAEio:';
    Label37.Caption := 'p[(16i\):';
    Label38.Caption := '[d:';
    Label39.Caption := 'NeBJ:';
    Label40.Caption := 'd:';
    Label41.Caption := 'IC:';
    Label42.Caption := 'ݗe:';
    Label43.Caption := 'ݓd:';
    Label44.Caption := '[d:';
    Label46.Caption := 'ACC:';
    Label47.Caption := 'obeEtO(16i\):';
    Label48.Caption := 'Ӗ:';
    Label49.Caption := 'obecp[Zg:';
    Label50.Caption := 'obec莞:';
    Label51.Caption := 'obeEt:';
    Label52.Caption := 'obe[dc莞:';
    Button1.Caption := 'ĕ\';
    CheckBox1.Caption := 'ĕ\(1b)';
  end else begin
    MenuLanguageJapanese.Checked := False;
    MenuLanguageEnglish.Checked := True;
    MenuFile.Caption := '&File';
    MenuFileSave.Caption := '&Save';
    MenuFileExit.Caption := 'E&xit';
    MenuLanguage.Caption := '&Language';
    MenuLanguageJapanese.Caption := '&Japanese';
    MenuLanguageEnglish.Caption := '&English';
    MenuAbout.Caption := '&About';
    MenuAboutVersion.Caption := '&Version';
    Label2.Caption := 'BatteryTag:';
    Label4.Caption := 'Capabilities(Hex):';
    Label5.Caption := 'BATTERY_CAPACITY_RELATIVE:';
    Label6.Caption := 'BATTERY_IS_SHORT_TERM:';
    Label7.Caption := 'BATTERY_SET_CHARGE_SUPPORTED:';
    Label8.Caption := 'BATTERY_SET_DISCHARGE_SUPPORTED::';
    Label9.Caption := 'BATTERY_SYSTEM_BATTERY:';
    Label10.Caption := 'Technology:';
    Label11.Caption := 'Chemistry:';
    Label12.Caption := 'DesignedCapacity:';
    Label13.Caption := 'FullChargedCapacity:';
    Label14.Caption := 'DefaultAlert1:';
    Label15.Caption := 'DefaultAlert2:';
    Label16.Caption := 'CriticalBias:';
    Label17.Caption := 'CycleCount:';
    Label19.Caption := 'Entry:';
    Label20.Caption := 'Granularity(0):';
    Label21.Caption := 'Capacity(0):';
    Label22.Caption := 'Granularity(1):';
    Label23.Caption := 'Capacity(1):';
    Label24.Caption := 'Granularity(2):';
    Label25.Caption := 'Capacity(2):';
    Label26.Caption := 'Granularity(3):';
    Label27.Caption := 'Capacity(3):';
    Label29.Caption := 'BatteryTemperature:';
    Label30.Caption := 'BatteryEstimatedTime:';
    Label31.Caption := 'BatteryDeviceName:';
    Label32.Caption := 'BatteryManufactureDate:';
    Label33.Caption := 'BatteryManufactureName:';
    Label34.Caption := 'BatteryUniqueID:';
    Label35.Caption := 'BatterySerialNumber:';
    Label37.Caption := 'PowerState(Hex)';
    Label38.Caption := 'BATTERY_CHARGING:';
    Label39.Caption := 'BATTERY_CRITICAL:';
    Label40.Caption := 'BATTERY_DISCHARGING:';
    Label41.Caption := 'BATTERY_POWER_ON_LINE:';
    Label42.Caption := 'Capacity:';
    Label43.Caption := 'Voltage:';
    Label44.Caption := 'Rate:';
    Label46.Caption := 'ACLineSatus:';
    Label47.Caption := 'BatteryFlag(Hex):';
    Label48.Caption := 'Mean:';
    Label49.Caption := 'BatteryLifePercent:';
    Label50.Caption := 'BatteryLifeTime:';
    Label51.Caption := 'BatteryFullLifeTime:';
    Label52.Caption := 'BatteryChargeCompletionTime:';
    Button1.Caption := 'Refresh';
    CheckBox1.Caption := 'Auto Refresh(1s)';
  end
end;

//
// CxgEnh
//

//
// {
//
procedure TForm1.MenuLanguageJapaneseClick(Sender: TObject);
begin
  Jp := True;
  LanguageCheck(Jp);
  ShowBattInfo()
end;

//
// p
//
procedure TForm1.MenuLanguageEnglishClick(Sender: TObject);
begin
  Jp := False;
  LanguageCheck(Jp);
  ShowBattInfo()
end;

//
// I
//
procedure TForm1.MenuFileExitClick(Sender: TObject);
begin
  Close
end;

//
// ComboBox
//
procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  ShowBattInfo()
end;

//
// FormCreate
//
procedure TForm1.FormCreate(Sender: TObject);
var
  ii: Integer;
  FullPath: String;
begin
  // EditzƂĈ
  for ii := 1 to Length(EditArray) do begin
    EditArray[ii] := TEdit(FindComponent('Edit' + IntToStr(ii)))
  end;
  Form1.DoubleBuffered := True;
  for ii := 1 to Length(EditArray) do begin
    EditArray[ii].DoubleBuffered := True;
    EditArray[ii].Text := '';
    EditArray[ii].ReadOnly := True
  end;
  // init@C
  FullPath := ChangeFileExt(Application.ExeName, '.ini');
  Jp := Boolean(GetPrivateProfileInt('Setup',
                                     'Japanese',
                                     0, PChar(FullPath)));
  CheckBox1.Checked := Boolean(GetPrivateProfileInt('Setup',
                                              'AutoRefresh',
                                              0, PChar(FullPath)));
  // ݒ
  LanguageCheck(Jp);
  //
  EnumBattInfo();
  ShowBattInfo()
end;

//
// Refresh
//
procedure TForm1.Button1Click(Sender: TObject);
begin
  ShowBattInfo()
end;

//
// Auto Refresh
//
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then begin
    Timer1.Enabled := True
  end else begin
    Timer1.Enabled := False
  end
end;

//
// ^C}ŃtbV
//
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  ShowBattInfo()
end;

//
// t@Cۑ
//
procedure TForm1.MenuFileSaveClick(Sender: TObject);
var
  StringList1: TStringList;
  strNoSystemBattery: String;
begin
  if Jp then begin
    strNoSystemBattery := 'VXeEobe'
  end else begin
    strNoSystemBattery := 'No system battery'
  end;
  if SaveDialog1.Execute then begin
    StringList1 := TStringList.Create;
    if BattNum = 0 then begin
      StringList1.Add(strNoSystemBattery)
    end else begin
      StringList1.Add('BatteryDevicePath: ' +
        BatteryDevicePath[ComboBox1.ItemIndex]);
      StringList1.Add(Label1.Caption);
      StringList1.Add(Label2.Caption + ' ' + Edit1.Text);
      StringList1.Add(Label3.Caption);
      StringList1.Add(Label4.Caption + ' ' + Edit2.Text);
      StringList1.Add(Label5.Caption + ' ' + Edit3.Text);
      StringList1.Add(Label6.Caption + ' ' + Edit4.Text);
      StringList1.Add(Label7.Caption + ' ' + Edit5.Text);
      StringList1.Add(Label8.Caption + ' ' + Edit6.Text);
      StringList1.Add(Label9.Caption + ' ' + Edit7.Text);
      StringList1.Add(Label10.Caption + ' ' + Edit8.Text);
      StringList1.Add(Label11.Caption + ' ' + Edit9.Text);
      StringList1.Add(Label12.Caption + ' ' + Edit10.Text);
      StringList1.Add(Label13.Caption + ' ' + Edit11.Text);
      StringList1.Add(Label14.Caption + ' ' + Edit12.Text);
      StringList1.Add(Label15.Caption + ' ' + Edit13.Text);
      StringList1.Add(Label16.Caption + ' ' + Edit14.Text);
      StringList1.Add(Label17.Caption + ' ' + Edit15.Text);
      StringList1.Add(Label18.Caption);
      StringList1.Add(Label19.Caption + ' ' + Edit16.Text);
      StringList1.Add(Label20.Caption + ' ' + Edit17.Text);
      StringList1.Add(Label21.Caption + ' ' + Edit18.Text);
      StringList1.Add(Label22.Caption + ' ' + Edit19.Text);
      StringList1.Add(Label23.Caption + ' ' + Edit20.Text);
      StringList1.Add(Label24.Caption + ' ' + Edit21.Text);
      StringList1.Add(Label25.Caption + ' ' + Edit22.Text);
      StringList1.Add(Label26.Caption + ' ' + Edit23.Text);
      StringList1.Add(Label27.Caption + ' ' + Edit24.Text);
      StringList1.Add(Label28.Caption);
      StringList1.Add(Label29.Caption + ' ' + Edit25.Text);
      StringList1.Add(Label30.Caption + ' ' + Edit26.Text);
      StringList1.Add(Label31.Caption + ' ' + Edit27.Text);
      StringList1.Add(Label32.Caption + ' ' + Edit28.Text);
      StringList1.Add(Label33.Caption + ' ' + Edit29.Text);
      StringList1.Add(Label34.Caption + ' ' + Edit30.Text);
      StringList1.Add(Label35.Caption + ' ' + Edit31.Text);
      StringList1.Add(Label36.Caption);
      StringList1.Add(Label37.Caption + ' ' + Edit32.Text);
      StringList1.Add(Label38.Caption + ' ' + Edit33.Text);
      StringList1.Add(Label39.Caption + ' ' + Edit34.Text);
      StringList1.Add(Label40.Caption + ' ' + Edit35.Text);
      StringList1.Add(Label41.Caption + ' ' + Edit36.Text);
      StringList1.Add(Label42.Caption + ' ' + Edit37.Text);
      StringList1.Add(Label43.Caption + ' ' + Edit38.Text);
      StringList1.Add(Label44.Caption + ' ' + Edit39.Text);
      StringList1.Add(Label52.Caption + ' ' + Edit46.Text);
      StringList1.Add(Label45.Caption);
      StringList1.Add(Label46.Caption + ' ' + Edit40.Text);
      StringList1.Add(Label47.Caption + ' ' + Edit41.Text);
      StringList1.Add(Label48.Caption + ' ' + Edit42.Text);
      StringList1.Add(Label49.Caption + ' ' + Edit43.Text);
      StringList1.Add(Label50.Caption + ' ' + Edit44.Text);
      StringList1.Add(Label51.Caption + ' ' + Edit45.Text)
    end;
    StringList1.SaveToFile(SaveDialog1.FileName);
    StringList1.Free
  end
end;

//
// CloseQuery
//
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  FullPath: String;
begin
  // init@C
  FullPath := ChangeFileExt(Application.ExeName, '.ini');
  WritePrivateProfileString('Setup', 'Japanese',
                            PChar(IntToStr(Integer(Jp))),
                            PChar(FullPath));
  WritePrivateProfileString('Setup', 'AutoRefresh',
                            PChar(IntToStr(Integer(CheckBox1.Checked))),
                            PChar(FullPath))
end;

//
// o[W\
//
procedure TForm1.MenuAboutVersionClick(Sender: TObject);
begin
  if Jp then begin
    Form2.Caption := 'AoEg - o[W'
  end else begin
    Form2.Caption := 'About - Version'
  end;
  Form2.Label1.Caption := ProgNameStr + ' ' + GetVersionInfo('FileVersion');
  Form2.Label2.Caption := VerDateStr;
  Form2.ShowModal
end;

end.
